#include <iostream>
#include <vector>

using namespace std;
const int N = 2e5;
int n, k, t;
vector<int> g[N];
int depth[N], pred[N];
vector<vector<int>> z;
vector<bool> used;
vector<int> pr;
vector<int> ve;

inline void find_d(int v, int p, int d, int D) {
    ve[d] = v;
    for (int to: g[v]) {
        if (to != p) {
            find_d(to, v, d + 1, D);
        }
    }
    if (d >= D) {
        pr[v] = ve[d - D];
    }
}

inline void dfs(int v, int p, int d) {
    depth[v] = d;
    pred[v] = p;
    for (int to: g[v]) {
        if (to != p) {
            dfs(to, v, d + 1);
        }
    }
}

inline void upd(int v, int p, int d) {
    used[v] = true;
    for (int to: g[v]) {
        if (to != p && !used[to]) {
            upd(to, v, d + 1);
        }
    }
}

inline bool check(int d) {
    used.assign(n, false);
    z.assign(n, vector<int>(0));
    for (int i = 0; i < n; ++i) {
        z[depth[i]].push_back(i);
    }
    vector<int> sz(n);
    for (int i = 0; i < n; ++i) {
        sz[i] = (int) z[i].size() - 1;
    }
    int k1 = k;
    int id = (int) z.size() - 1;
    while (id >= 0) {
        if (id <= d + 1) {
            return true;
        }
        while (sz[id] >= 0) {
            int v = z[id][sz[id]];
            sz[id]--;
            if (used[v])continue;
            v = pr[v];
            used[v] = true;
            upd(v, pred[v], 1);
            k1--;
            if (k1 < 0)return false;
            sz[id]--;
        }
        id--;
    }
}

void solve() {
    cin >> n >> k >> t;
    bool e = true;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
        if (!(u == i && v == i + 1))e = false;
    }
    int l, r, mid;
    if (e) {
        if (t == 0) {
            l = 0;
            r = n - 1;
            while (l + 1 < r) {
                mid = (l + r) / 2;
                if ((n - 2) / mid > k) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            cout << r;
        } else {
            for (int i = 0; i < n; ++i) {
                l = 0;
                r = n;
                while (l + 1 < r) {
                    mid = (l + r) / 2;
                    if (max((int) 0, i - 1) / mid + (n - i - 2) / mid > k) {
                        l = mid;
                    } else {
                        r = mid;
                    }
                }
                cout << r << " ";
            }
        }
        return;
    }
    if (t == 0) {
        dfs(0, 0, 0);
        l = 0;
        r = n - 1;
        pr.assign(n, 0);
        ve.assign(n, 0);
        while (l + 1 < r) {
            mid = (l + r) / 2;
            find_d(0, 0, 0, mid - 1);
            if (check(mid)) {
                r = mid;
            } else {
                l = mid;
            }
        }
        cout << r;
    } else {
        for (int i = 0; i < n; ++i) {
            pr.assign(n, i);
            ve.assign(n, i);
            dfs(i, i, 0);
            l = 0;
            r = n - 1;
            while (l + 1 < r) {
                mid = (l + r) / 2;
                find_d(i, i, 0, mid - 1);
                if (check(mid)) {
                    r = mid;
                } else {
                    l = mid;
                }
            }
            cout << r << " ";
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}